#!/usr/bin/env node
const https = require('https');
const path = require('path');
const fs = require('fs');

source = 'https://raw.githubusercontent.com/awslabs/amazon-eks-ami/master/files/eni-max-pods.txt';
outputFile = path.join(__dirname, '..', 'lib', 'instance-data.ts');

https.get(source, res => {
  const output = [];
  res.on('data', chunk => output.push(chunk));
  res.on('end', () => {
    const data = Buffer.concat(output).toString('utf-8');
    const array = data.split('\n').filter(x => x.length > 0 && !x.startsWith('#')).map(line => {
      const [ type, countStr ] = line.split(' ');
      const count = parseInt(countStr);
      return [ type, count ];
    });

    const content = `
// Generated by: scripts/update-instance-data.js
// Source: ${source}
// Timestamp: ${new Date().toISOString()}

export const MAX_PODS = Object.freeze(new Map(${JSON.stringify(array, undefined, 2)}));
`.trim();

    fs.writeFileSync(outputFile, content);
  });
});

